#!/usr/bin/python
# -*- coding: utf-8 -*-

import os
import fnmatch
import time
import sys
import platform

# from daemon import runner

from os import listdir
from os.path import isfile, join

# sys.path.insert(0, './daemon.py')

from daemon import *


class myDaemon(Daemon):

    def __init__(self):
        Daemon.__init__(self, '/tmp/foo.pid')
        self.workingDirectory1 = sys.path[0] + '/static/output_images'  # percorso relativo da dove risiede lo script
        self.workingDirectory2 = sys.path[0]  # percorso relativo da dove risiede lo script

    def getOnlyFilesList(self,path):
        return [f for f in listdir(path) if isfile(join(path, f))]

    def extractTimeStampFromFileName(self,file):
        fileName = os.path.splitext(file)[0]  # solo nome del file, senza estensione
        timestampStr = fileName.split('.')[0]  # prendiamo la prima parte del nome del file, quella con il timestamp
        if 'tree_' in timestampStr:     #se è qualcosa tipo tree_<timeStamp>, dobbiamo ancora recuperare il timeStamp
            timestampStr = timestampStr.split('tree_')[1]
        return timestampStr

    def deleteImages(self, currentTime):
        os.chdir(self.workingDirectory1)
        onlyfiles = self.getOnlyFilesList(self.workingDirectory1)

        # print onlyfiles

        for file in onlyfiles:
            try:  # se solleva un'eccezione lasciamo correre, il file sara' eliminato prossima volta
                timestampStr = self.extractTimeStampFromFileName(file)
                timestampInt = int(timestampStr)  # interpretiamo il timestamp come numero intero
                if timestampInt < (currentTime - 60*60):  # il file deve essere stato creato da almeno un'ora

            # print(file)

                    os.remove(file)
            except:
                pass

    def deleteDotFiles(self, currentTime):
        os.chdir(self.workingDirectory2)
        onlyfiles = self.getOnlyFilesList(self.workingDirectory2)

        # print onlyfiles

        for file in onlyfiles:
            try:  # se solleva un'eccezione lasciamo correre, il file sara' eliminato prossima volta
                timestampStr = self.extractTimeStampFromFileName(file)
                timestampInt = int(timestampStr)  # interpretiamo il timestamp come numero intero
                if timestampInt < (currentTime - 60*60):  # il file deve essere stato creato da almeno un'ora

            # print(file)

                    os.remove(file)
            except:
                pass

    def run(self):
        while True:
            currentTime = round(time.time())  # arrotondiamo il tempo
            self.deleteImages(currentTime)
            self.deleteDotFiles(currentTime)
            time.sleep(60 * 90)  # dorme per un'ora e mezza


# app = myDaemon()
# daemon_runner = runner.DaemonRunner(app)
# daemon_runner.do_action()

app = myDaemon()

if platform.system() not in ['Java' and 'Windows']:  # sotto Win non esiste os.fork()
    app.start()
