function DatasetManager(){
	this.datasetContainer = {};
	
	this.sortDatasetAlphabeticallyComparator = function(a, b) {
		return a.title.localeCompare(b.title);
	}

	this.sortDatasetByIdComparator = function(a, b) {
		return a.id < b.id ? -1 : (a.id > b.id ? 1 : 0);
	}

	this.checkFields = function(fieldsArray){
		var c = -1;//se array è vuoto c vale -1
		if(typeof fieldsArray !== 'undefined' && fieldsArray.length > 0){
			for(c=0;c<fieldsArray.length;c++){
				if(typeof fieldsArray[c] === 'undefined')break;
			}
		}
		return c === fieldsArray.length;
	}
}

	DatasetManager.prototype.getDatasetContainer = function(){return this.datasetContainer;}

	DatasetManager.prototype.addType = function(type){
		if(this.checkFields([type])){						  
			if(!(type in this.datasetContainer)){
				this.datasetContainer[type] = {};
			}
		}
	}

	DatasetManager.prototype.addDataset = function(datasetId,type,dataset){
		var filteredDataset = [];
		if(this.checkFields([type])){											
			this.addType(type);//se non esiste il tipo lo creiamo uno vuoto
			this.datasetContainer[type][datasetId] = dataset;
		}
	}

	DatasetManager.prototype.getDatasetByType = function(type){
		var filteredDataset = [];
		if(this.checkFields([type])){					  						  
			this.addType(type);//se non esiste il tipo di dataset ne creiamo uno vuoto
			var datasetType = this.datasetContainer[type];
			for(var id in datasetType){
				filteredDataset.push(datasetType[id]);
			}
		}
		return filteredDataset;
	}

	DatasetManager.prototype.getDatasetByID = function(id,type){
		if(this.checkFields([id,type])){							 
			this.addType(type);//se non esiste il tipo lo creiamo uno vuoto
			var datasetType = this.datasetContainer[type];
			return datasetType[id];
		}
	}
	
	DatasetManager.prototype.deleteDatasetByID = function(id,type){
		if(this.checkFields([id,type])){							 
			var datasetType = this.datasetContainer[type];
			if(typeof datasetType[id] !== 'undefined'){
				delete datasetType[id];
				return true;
			}
		}
	}

	DatasetManager.prototype.sortDatasetAlphabetically = function(datasetType,customComparator){
		var datasets = this.getDatasetByType(datasetType);
		var comparator = customComparator ? customComparator : this.sortDatasetAlphabeticallyComparator;
		return datasets.sort(comparator);
	}

	DatasetManager.prototype.sortDatasetById = function(datasetType){
		var This = this;
		var datasets = this.getDatasetByType(datasetType);
		return datasets.sort(This.sortDatasetByIdComparator);
	}