var currentAlgName;
var imageNumber = 0;//per convenzione è la primissima immagine. Serve nello step by step per conoscere la prox immagine

var MAX_POINTS = options.KMeans.num_points;//numero di punti massimi

function deletePointRow(caller) {
    $(caller).parent().prev().remove();
    $(caller).parent().remove();
	if((getPointsNumber().length) <= MAX_POINTS)//controlliamo che adesso i punti tornino alla loro dimensione consentita
		$("#dataset_size_exceeded_error").hide();
	var points_number = getPointsNumber();//rinumeriamo i punti nel caso l'utente non li cancelli in ordine 
	$(points_number).each(function(index,el){
		$(el).text('P' + index);
	});
}

function addPoint(x, y, shouldValidatePoints) {
	var addPointsFunc = function(dataReturned){
		//normalizziamo e eleminiamo gli undefined
		x = x ? x.trim() : '';
		y = y ? y.trim() : '';
		
		if((getPointsNumber().length) === MAX_POINTS)
			$("#dataset_size_exceeded_error").show();
		else {
			$("#valuesContainer").append(dataReturned);
			getX().last().val(x);
			getY().last().val(y);
			var points_number = getPointsNumber().length - 1;//siccome parte da 0, P0,P1...
			getPointsNumber().last().text('P' + points_number);
			if (shouldValidatePoints)
				validatePoints();
		}
	}//una volta recuperato il template di una singola riga del dataset,lo salviamo in locale (cache) e lo riempiamo di dati
	getAddPointTemplate(addPointsFunc);

}

function getX() {
    return $("#valuesContainer .x");
}

function getY() {
    return $("#valuesContainer .y");
}

function getPointsNumber() {
    return $("#valuesContainer .point_number");
}

function getAddPointTemplate(callbackFunc){
	return getTemplate('getTemplate', 'numeric_dataset_row_template.html',undefined,callbackFunc);
}

function validatePoints() {
    var x = [],
        y = [];
	var response = 'ok';
    var currentVal;
    getX().each(function(index, el) {
        currentVal = el.value;
        if ($.isNumeric(el.value)) {
            removeError(el);
        } else {
            setError(el, "Invalid point");
			response = 'invalid-data'
        }
		if((typeof currentVal !== 'undefined')&&(currentVal !== ''))
			x.push(currentVal);
    });
    getY().each(function(index, el) {
        currentVal = el.value;
        if ($.isNumeric(el.value)) {} else {
            setError(el, "Invalid point");
			response = 'invalid-data'
        }
		if((typeof currentVal !== 'undefined')&&(currentVal !== ''))
			y.push(currentVal);
    });
    return {
        x: x,
        y: y,
		status: response
    };
}

function saveCallback(datasetType, datasetId) {//serve a aggiornare un dataset oppure a crearlo uno nuovo
    var currentDatasetModel = copyDatasetModel();
    currentDatasetModel.title = getTitleModal("myModal");
    if (currentDatasetModel.title !== "") {
        currentDatasetModel.type = datasetType;
        currentDatasetModel.data = validatePoints();//salvo i punti del dataset dentro il modal dialog
        currentDatasetModel.id = (typeof datasetId !== 'undefined') ? datasetId : Date.now();//salviamo l'id del dataset, se non è dato lo creiamo
        //if (operationType === 'create') datasetContainer[currentDatasetModel.id] = currentDatasetModel;
        //else if (operationType === 'update') datasetContainer[datasetId] = currentDatasetModel;
		datasetManager.addDataset(currentDatasetModel.id,currentDatasetModel.type,currentDatasetModel);
        initPage(datasetType);
    }
}

$(document).ready(function() {
	currentAlgName = $("#algName").text();//recupero il nome dell'algoritmo
	MAX_POINTS = getAlgOptions(currentAlgName).num_points;//recuperiamo dalle opzioni il numero massimo di punti
    $(document).off('click', '#available_dataset .single-dataset');
    
	if (!embeddedPage){
		//controlliamo che sia stata richiesta direttamente una pagina specifica per un certo algoritmo
		//le pagine degli algoritmi possono essere richieste in modo specifico da una URL oppure possono essere inserite in una pagina già esistente dal JS
		initPage(getAlgType(currentAlgName));
		if(supportHistoryAPI())
			history.pushState({requestedRoute:currentRoute,algType:getAlgType(currentAlgName)},'Didactic Data Mining', currentRoute);
	}
	menuHighlightAlg(currentAlgName);//evidenziamo nel menu degli algoritmi quello corrente
	insertWikiLink(currentAlgName);	
	
	$("#max_num_point").text(MAX_POINTS);//setto il numero di punti massimo per un eventuale messaggio d'errore nel dialog per inserire i punti
	$(document).on('click', '#available_dataset .single-dataset', function() {
		var datasetId = $(this).attr('data-id');//Number($(this).attr('data-id'));//estraiamo id del dataset cliccato dall'utente
		var datasetType = $(this).attr('data-type');
		var x = [],
		y = [];
		if (datasetType === "numeric") {
			var points = datasetManager.getDatasetByID(datasetId,datasetType).data;//con id recuperiamo i punti associati al dataset
			x = points.x;
			y = points.y;
		}
		var template = datasetType === 'numeric' ? 'numeric_dataset_detail.html' : 'text_dataset_detail.html';
		var title = datasetManager.getDatasetByID(datasetId,datasetType).title;
		$.when(getTemplate('/getTemplate', template)).then(function(data) {
			var newCallback = function() {
				saveCallback(datasetType, datasetId);
			};
			showModal("myModal", title,data, newCallback,datasetId,"edit");
			$("#show_dataset_id .dataset_id").text(datasetId);
			$.when(getAddPointTemplate()).then(function(){
				for (var c = 0; c < x.length; c++) {	
					if(c < MAX_POINTS)
						addPoint(x[c], y[c], true);
					else{//se i punti sono troppi l'utente non vedrà i punti di troppo
						$("#dataset_size_exceeded_error").show();
						break;
					}	
				}
			});
		});
	});
    $('#step_by_step_switch').on('change',function(){
		imageNumber = 0;//reset contantore posizione immagine corrente (il template gestisce l'indice se sfora)
		//cancelliamo le altre immagini visualizzate se presenti con una piccola animazione
		$("#drawSurface > :not(#btn_control_image_flow)").fadeOut(function(){this.remove();});
	});
	//$(document).on("click","#file-1",function(){readFromCSV(this);});
    registerActionOnEnterKeyPress($("#myModal"),function(){$("#save_button_modal").click();});//premere invio nel modal è come premere il bottone salva
	if( /Android|webOS|iPhone|iPad|iPod|BlackBerry/i.test(navigator.userAgent) ) {
		$('.selectpicker').selectpicker('mobile');//da mobile la select usa viene gestita internamente dal browser
	}
});

function exportToCSV() {
    var string = CSV_COMMENT + "dataset_id,dataset_title,dataset_type,dataset_x,dataset_y\n";
	string += CSV_COMMENT + "ALL comments must be in a new line\n"
    var numeric_dataset = datasetManager.getDatasetByType('numeric');

    numeric_dataset.sort(sortDatasetById);
    //per ogni dataset creiamo una riga con titolo-typo-coordinata x- coordinata y
    //NB: se il dataset D ha N coordinate, allora nel CSV il dataset D sarà costituito da N righe
    for (var c = 0; c < numeric_dataset.length; c++) {
        var item = numeric_dataset[c];
        for (var d = 0; d < item.data.x.length; d++) {
            string += item.id + ',' + item.title + ',' + item.type + ',' + item.data.x[d] + ',' + item.data.y[d] + '\n';
        }
    }
    return string;
}
/*/
function readFromCSV(input) {
	const NUMBER_OF_COLUMNS = 5;
	const IGNORE_FIRST_LINE = false; //la prima riga potrebbe essere usata per descrivere i campi
	var files = input instanceof jQuery ? input[0].files : input.files; //se è un oggetto jQuery occorre accedere all'oggetto JS invece
	var text;
	var jsonFiles = {};
	var l = 0;
	var readFileFunc = function(theFile) {
		var text = reader.result;
		var lines = text.split('\n');
		for (var c = 0; c < lines.length; c++) {
			//ignoriamo il delimitatore di commento e forse la prima riga
			if (lines[c].substr(0, CSV_COMMENT.length) !== CSV_COMMENT && ((IGNORE_FIRST_LINE && c !== 0) || !IGNORE_FIRST_LINE)) {
				var CSVrow = lines[c];
				var CSVfields = CSVrow.split(',');
				if ((CSVfields.length > 0) && (CSVfields.length === NUMBER_OF_COLUMNS) && (CSVfields[0].trim())) {//ci assicuriamo di parsare una riga corretta
					var currentDatasetModel;
					var id = CSVfields[0].trim();
					currentDatasetModel = jsonFiles[id] ? jsonFiles[id] : copyDatasetModel();
					currentDatasetModel.id = CSVfields[0].trim();
					currentDatasetModel.title = CSVfields[1].trim();
					currentDatasetModel.type = CSVfields[2].trim();
					if(currentDatasetModel.type === 'numeric'){
						if (typeof currentDatasetModel.data.x == 'undefined')
						currentDatasetModel.data.x = [];
						if (typeof currentDatasetModel.data.y == 'undefined')
						currentDatasetModel.data.y = [];
						currentDatasetModel.data.x.push(CSVfields[3].replace('\r', '').trim());
						currentDatasetModel.data.y.push(CSVfields[4].replace('\r', '').trim());
						if (!jsonFiles[id]) //significa che è un elemento nuovo
						jsonFiles[id] = currentDatasetModel;
					}
					else {
						bootbox.alert("You did not provide a numeric dataset, it will be ignored");
						break;
					}
				}
			}
			
		}//sappiamo che abbiamo letto tutti i file in input
		if (l == files.length) {
			updateavailableDatasetFromJSON(jsonFiles);
			injectMainPageTemplate(this, '/KMeans', 'numeric_dataset.html', undefined, {
				algName: 'K-Means',
				type: 'numeric'
			});
		}
	}

	for (var l = 0; l < files.length; l++) {
		var reader = new FileReader();
		reader.onload = (readFileFunc);
		reader.readAsText(files[l]);
	}
	return jsonFiles;
}
/*/
function generateRandomDataset(numpoints, minvalue, maxvalue) {
	var algOptions;
	switch (currentAlgName){
	    case NUMERIC_ALG_NAME.KMeans:
			path = '/'+NUMERIC_ALG_NAME.KMeans+'/generate_numeric_dataset';
			algOptions = options.KMeans;//andiamo a prendere l'opzione per l'algoritmo
			break;
	    case NUMERIC_ALG_NAME.Dbscan:
			path = '/'+NUMERIC_ALG_NAME.Dbscan+'/generate_numeric_dataset';
			algOptions = options.Dbscan;
			break;
	    case NUMERIC_ALG_NAME.Hierarchical:
			path = '/'+NUMERIC_ALG_NAME.Hierarchical+'/generate_numeric_dataset';
			algOptions = options.Hierarchical;
			break;
	}
    $.get(path,{algOptions:JSON.stringify(algOptions)}, function(dataset) {
        var template = 'numeric_dataset_detail.html';
        $.when(getTemplate('getTemplate', template)).then(function(data) {
            var newCallback = function() {
                saveCallback('numeric');
            };
            showModal("myModal", "", data, newCallback,undefined,"create");
			//se non abbiamo il template da usare per ogni riga lo chiediamo al server sennò usiamo la versione già scaricata
			$.when(getAddPointTemplate()).then(function(){
				for (key in dataset) {
					addPoint(dataset[key][0].toString(), dataset[key][1].toString(), false);
				}
			});
        });
    });
}

function getCurrentAlgOptions(algName){
	var algOptions;
	switch (algName){
			case NUMERIC_ALG_NAME.KMeans:
				algOptions = options.KMeans;//andiamo a prendere l'opzione per l'algoritmo
				break;
			case NUMERIC_ALG_NAME.Dbscan:
				algOptions = options.Dbscan;
				break;
			case NUMERIC_ALG_NAME.Hierarchical:
				algOptions = options.Hierarchical;
				break;
	}
	return algOptions;
}

function draw(algName) {
	var path = '';
	var algOptions = getCurrentAlgOptions(algName);//andiamo a prendere l'opzione per l'algoritmo
	
	switch (algName){
	case NUMERIC_ALG_NAME.KMeans:
		path = '/'+NUMERIC_ALG_NAME.KMeans+'/draw_dataset';
		break;
	case NUMERIC_ALG_NAME.Dbscan:
		path = '/'+NUMERIC_ALG_NAME.Dbscan+'/draw_dataset';
		break;
	case NUMERIC_ALG_NAME.Hierarchical:
		path = '/'+NUMERIC_ALG_NAME.Hierarchical+'/draw_dataset';
		break;
	}
	var error = false;
	var stepByStep = ($("#step_by_step_switch")[0]).checked;//controlliamo lo stato del toggle per lo step by step
	var datasetID = $('#datasetSelect').val();
	if((typeof datasetID !== 'undefined') && datasetID !== ''){	
		var datasetData = datasetManager.getDatasetByID(datasetID,"numeric").data;
		if (datasetData.x.length == 0 && datasetData.x.length == 0){
			error = true;
			bootbox.alert("This appear to be an empty dataset");
		}
		else if (datasetData.status === 'invalid-data'){
			error = true;
			bootbox.alert("This dataset contains invalid data, please correct");
		}
		else {
			
			if( typeof algOptions.centroid_index_c1 !== 'undefined'){
				var c1 = algOptions.centroid_index_c1;
				var c2 = algOptions.centroid_index_c2;
				var max_index = datasetData.x.length-1;
				if((c1 > max_index)||(c2 > max_index)||(c1 === c2)){
					bootbox.alert("Invalid centroid indexes detected in the current dataset!");
					return;
				}
			}

			var points = JSON.stringify(datasetData); 
			$.LoadingOverlay("show");
			$.ajax({
				url:path,
				data:{
				points: points,
				stepByStep: stepByStep,
				imageNumber : imageNumber,//se non si mette step by step imageNumber non viene usata lato server
				algOptions : JSON.stringify(algOptions,optionsStringifier)
				}, 
				success:function(result) {
					if(!stepByStep && currentAlgName == NUMERIC_ALG_NAME.Hierarchical)
						$("#drawSurface").css("display","block");	
					else 
						$("#drawSurface").css("display","inline-block");					
					if(stepByStep) {
						/*/in pratica la nuova immagine la spingiamo dal basso in modo che sia sopra la vecchia immagine, la vecchia immagine
						dovrà stare sopra la nuova con uno z-index più alto, poi rimuoviamo la vecchia immagine cosi sotto ci troviamo quella nuova,
						la nuova immagine poi per non essere sfasata rispetto alla pagina dovra avere bottom:0px perchè adesso la vecchia immagine non esiste più/*/
						$("#drawSurface #btn_control_image_flow").before(result);
						$("#btn_control_image_flow").removeClass('hidden');
						var first_image = $("#drawSurface .single_image").first();
						var second_image = $("#drawSurface .single_image").slice(1,2);
						second_image.css("position","relative");
						var h = first_image.css('height');
						first_image.css('z-index',5);
						second_image.css("bottom",h);
						if($("#drawSurface img").length > 1){
							first_image.animate({ opacity: 0 },{complete:function(){
									first_image.remove();//rimuoviamo la vecchia immagine
									second_image.css('bottom','initial');}});				
						}
					}
					else {//se dobbiamo mostrare tutte le immagini una dopo l'altra tutte insieme
						clearSurface();
						$("#drawSurface #btn_control_image_flow").before(result);
						$("#btn_control_image_flow").addClass('hidden');//nascondiamo i controlli per le immagini
					}
				},
				complete:function(){$.LoadingOverlay("hide");},
				error:function(){
					clearSurface();
					bootbox.alert("An error occured during server communication");
				}
			});
		}
	}
	else {
		error = true;
		bootbox.alert("Please select a dataset");
	}
	if(error)
		clearSurface();
}


function showSettings(algName){
	var optionsList;
	var currentDatasetOptions;
    switch (algName){
	    case NUMERIC_ALG_NAME.KMeans:
			path = '/'+NUMERIC_ALG_NAME.KMeans+'/options';
			currentDatasetOptions = options.KMeans;
			break;
	    case NUMERIC_ALG_NAME.Dbscan:
			path = '/'+NUMERIC_ALG_NAME.Dbscan+'/options';
			currentDatasetOptions = options.Dbscan;
			break;
	    case NUMERIC_ALG_NAME.Hierarchical:
			path = '/'+NUMERIC_ALG_NAME.Hierarchical+'/options';
			currentDatasetOptions = options.Hierarchical;
			break;
    }	
	var args = {algName:algName};
	var saveOptionsCallback = function(args) {//aggiorniamo le opzioni dell'algoritmo con i nuovi valori
		validateOptions(optionsList,true);//segna in rosso le opzioni non valide e riporta ai valori predefiniti i campi non validi
		var min_value = Math.round(Number($("#min_value").val()));//min value,max,num points sono disabilitati nel template, verranno usati i valori di default in utils.js
		var max_value = Math.round(Number($("#max_value").val()));
		var num_points = Math.round(Number($("#num_points").val()));
		if(args.algName === NUMERIC_ALG_NAME.KMeans){
			var centroid_index_c1 = Math.round(Number($("#centroid_index_c1").val()));
			var centroid_index_c2 = Math.round(Number($("#centroid_index_c2").val()));
			if((typeof centroid_index_c1 !== 'undefined') && (typeof centroid_index_c2 !== 'undefined') && (centroid_index_c1 !== centroid_index_c2)){
				options.KMeans.centroid_index_c1 = centroid_index_c1;
				options.KMeans.centroid_index_c2 = centroid_index_c2;
			}
		}
		else if(args.algName === NUMERIC_ALG_NAME.Hierarchical){
			var link_criteria = $("#link_criteria").val();
			options.Hierarchical.link_criteria = link_criteria;
			var use_distances = $("#use_distances").val();
			options.Hierarchical.use_distances = use_distances;
		}
		else if(args.algName === NUMERIC_ALG_NAME.Dbscan){
			var eps = Number($("#eps").val());
			var min_pts = Math.round(Number($("#min_pts").val()));
			options.Dbscan.eps = (eps && (eps > 0)) ? eps : options.Dbscan.eps;
			options.Dbscan.min_pts = (min_pts && (min_pts > 0)) ? min_pts : options.Dbscan.min_pts;
		}
		setCookie('options', JSON.stringify(options,optionsStringifier), 2);//mettiamo un cookie per salvare le opzioni, durata 2gg
		//se il nuovo valore è buono lo salviamo, altrimenti lo scartiamo
		
		/* currentDatasetOptions.min_value = ( (min_value || min_value === 0) && (min_value < max_value)) ? min_value : currentDatasetOptions.min_value;
		currentDatasetOptions.max_value = (max_value && (min_value < max_value)) ? max_value : currentDatasetOptions.max_value;
		currentDatasetOptions.num_points = num_points ? num_points : currentDatasetOptions.num_points; */
		//args['dialog'].modal('hide');//chiudiamo il dialog
		//console.log("nuove opzioni");console.log(currentDatasetOptions);
	}
					
	var f = function(dataReturned,args){//mostriamo i valori che abbiamo già nel menu delle opzioni
		var dialog = bootbox.dialog({
			title: 'Settings <span class="glyphicon glyphicon-cog grayColor"></span>',
			buttons: {
				close: {
					label: 'Close',
					className: "btn-danger"
				},
				confirm: {
					label: 'Save',
					className: "btn-info",
					callback: function(){
						saveOptionsCallback.call(this,args);
						unregisterEnterKeyPress($(".bootbox input"));
						$('option').off('change');
						}
				}
			},
			onEscape : true,
			backdrop: true,
			message: dataReturned
		});
		//args['dialog'] = dialog;
		$(dialog).find('.modal-body').css('overflow-y', 'auto'); 
		$(dialog).find('.modal-body').css('max-height', $(window).height() * 0.7);
		var currentDatasetOptions;
		if(args.algName === NUMERIC_ALG_NAME.KMeans){//mostriamo i valori che abbiamo già nel menu delle opzioni
			currentDatasetOptions = options.KMeans;
		}
		else if(args.algName === NUMERIC_ALG_NAME.Hierarchical){
			currentDatasetOptions = options.Hierarchical;
			$("#link_criteria").val(options.Hierarchical.link_criteria);
			$("#use_distances").val(String(options.Hierarchical.use_distances));
		}
		else if(args.algName === NUMERIC_ALG_NAME.Dbscan){
			currentDatasetOptions = options.Dbscan;
			$("#eps").val(options.Dbscan.eps);
			$("#min_pts").val(options.Dbscan.min_pts);
		}
		
		//controlliamo i centroidi quando mostriamo i loro valori
		var c1 = Number(options.KMeans.centroid_index_c1);
		var c2 = Number(options.KMeans.centroid_index_c2);
		$("#centroid_index_c1").val(c1);
		$("#centroid_index_c2").val(c2);
		optionsList = [$("#eps"),$("#min_pts"),$("#centroid_index_c1"),$("#centroid_index_c2"),$("#min_value"),$("#max_value"),$("#num_points")];
		validateOptions(optionsList);
		$("#min_value").val(currentDatasetOptions.min_value);
		$("#max_value").val(currentDatasetOptions.max_value);
		$("#num_points").val(currentDatasetOptions.num_points);
		//battere invio su un campo input è come cliccare il pulsante per chiudere
		registerActionOnEnterKeyPress($(".bootbox input"),function(){$(".bootbox button[data-bb-handler='confirm']").click();},args);
		$('.option').on('change',function(el){
			validateOptions(optionsList);//ogni volta che qualche input box cambia validiamo le opzioni e nel caso lo notifichiamo all'utente
		});
	}
	getTemplate(path,algName+'_options',args,f);//facciamo la richiesta di un template al termine esegue f con i dati del template restituiti
}

function validateOptions(HTMLOptions,normalize){
	HTMLOptions = HTMLOptions ? HTMLOptions : [];//delle opzioni da validare, se sono valide o meno, si aspetta il tag input da cui estrarre il valore min/max per il controllo
	//controlliamo i centroidi quando mostriamo i loro valori
	var c1 = Number($("#centroid_index_c1").val());
	var c2 = Number($("#centroid_index_c2").val());
	var datasetID = $('#datasetSelect').val(), max_index;
	if( (typeof datasetID !== 'undefined') && datasetID !== ''){	
		var datasetData = datasetManager.getDatasetByID(datasetID,"numeric").data;
		max_index = datasetData.x.length-1;
	}		
	removeError($("#centroid_index_c1,#centroid_index_c2"));	
	if(c1 === c2)	
		setError($("#centroid_index_c1,#centroid_index_c2"),'Overlapping centroids');
	if( (typeof max_index !== 'undefined') &&(c1 > max_index))
		setError($("#centroid_index_c1"),'C1 index exceeds the maximum current dataset\'s index');
	if( (typeof max_index !== 'undefined') &&(c2 > max_index))
		setError($("#centroid_index_c2"),'C2 index exceeds the maximum current dataset\'s index');
	for(var c=0;c<HTMLOptions.length;c++){
		var el = HTMLOptions[c];//prendiamo valori max/min se specificati in HTML, se ci sono confronto con il valore inserito dall'utente
		var min = $(el).attr('min');
		var max = $(el).attr('max');
		var currValue = $(el).val();
		if((typeof min !== 'undefined') && (typeof currValue !== 'undefined') && (Number(currValue) < Number(min))){
			setError($(el),'Current value lower than the minimum allowed');
			if(normalize)$(el).val(min);
		}
		if((typeof max !== 'undefined') && (typeof currValue !== 'undefined') && (Number(currValue) > Number(max))){
			setError($(el),'Current value greater than the maximum allowed');
			if(normalize)$(el).val(max);
		}
	}
}

function showInfo(algName){
	var algTitleDisplayed = "";
    switch (algName){
	    case NUMERIC_ALG_NAME.KMeans:
			path = '/'+NUMERIC_ALG_NAME.KMeans+'/info';
			algTitleDisplayed = NUMERIC_ALG_NAME.KMeans;
			break;
	    case NUMERIC_ALG_NAME.Dbscan:
			path = '/'+NUMERIC_ALG_NAME.Dbscan+'/info';
			algTitleDisplayed = NUMERIC_ALG_NAME.Dbscan;
			break;
	    case NUMERIC_ALG_NAME.Hierarchical:
			path = '/'+NUMERIC_ALG_NAME.Hierarchical+'/info';
			algTitleDisplayed = NUMERIC_ALG_NAME.Hierarchical;
			break;
    }
	var f = function(dataReturned){
		var dialog = bootbox.dialog({
			title: algTitleDisplayed + ' Info',
			message: dataReturned,
			buttons: {
				ok: {
					label: "Close",
					className: 'btn-info',
				}
			}
        });
		$(dialog).find('.modal-body').css('overflow-y', 'auto !important'); 
		$(dialog).find('.modal-body').css('max-height', $(window).height() * 0.7);
	}
	getTemplate(path,currentAlgName+'_info',undefined,f)//facciamo la richiesta di un template al termine esegue f con i dati del template restituiti
}
