//gestisce una tabella in maniera dinamica, dando per buono però che esista già un certo template per la tabella, definito in text_dataset_detail.html
function TableManager(tableID,WritePermission) {
    this.tableID = tableID;
	this.MAX_ROWS_NUMBER = 10;
	this.MAX_COLUMNS_NUMBER = 10;
	this.setWritePermission(WritePermission ? true : false);
		
	this.generateField = function(index, val) {
	//nel caso non gli sia dato un valore lo diamo noi di default, nel caso l'utente esprima meno valori di quante sono le colonne, verranno generati dei campi vuoti
		val = val ? val : '';
		return '<td data-columnIndex=' + index + '><div><input class="label_like rigaEl form-control" type="text" value="' + val + '"></div></td>';
	}
	
	this.generateDeleteRowButton = function(){
		return '<td><span onclick="tableManager.deleteRow(this);" class="glyphicon glyphicon-remove row_remove_button"></span></td>';
	}
	
	this.getHeaderRow = function(){
		return $("#" + this.tableID + " .headerRow");
	}
	
	this.getRowsClass = function(){return "riga";}
	
	this.getRows = function(){
		return $("#" + this.tableID + " ." + this.getRowsClass());
	}
	
	this.getFieldsInRow = function(row){
		return $(row).find('input');
	}

	this.copyColumnTemplate = function() {
		var newColumn = this.getHeaderRow().first().find("th").first().clone();
		$(newColumn).children("div.has-error").removeClass("has-error");//potrebbe avere un label con un tooltipi di errore il template da cui copiamo, quindi lo togliamo
		return newColumn;
	}
}

TableManager.prototype.setMaxRowsNumber = function(num) {
	this.MAX_ROWS_NUMBER = num;
	this.MAX_COLUMNS_NUMBER = num; //di default al massimo uguale num righe e colonne
}

TableManager.prototype.setMaxColumnsNumber = function(num) {
	this.MAX_COLUMNS_NUMBER = num;
}

TableManager.prototype.setWritePermission = function(val) {
	this.WritePermission = val;
	$("#" + this.tableID + ' input').prop("readonly",!val);
}
	
TableManager.prototype.show = function() {
	if(!this.WritePermission){
			$('#add_row').hide();
			$("#" + this.tableID + ' .glyphicon').hide();
	}
	$("#" + this.tableID + ' input').prop("readonly",!this.WritePermission);
}

TableManager.prototype.hideEmptyFields = function(){//nasconde le colonne vuote di una tabella
	var input = $("#" + this.tableID + ' input');
	input.each(function(index,el){
		if($(el).val() === ''){
			$(el).css("visibility","hidden");
			removeError($(el));
		}
	});
}

TableManager.prototype.deleteColumn = function(removeGlyphicon) {
    var parent = $(removeGlyphicon).parents("th,td");
    var colIndex = parent.attr("data-columnIndex");
	var This = this;
    if (parent.parent().children().length > 2) {
        $("td[data-columnIndex='" + colIndex + "'],th[data-columnIndex='" + colIndex + "']").remove();
        this.getHeaderRow().add(this.getRows()).each(function() {//add combina il risultato di due selettori in uno solo
            if ($(this).children().length === 0) 
				$(this).remove();
			var columnsNumber = This.getHeaderRow().children().length - 1;//non si può usare bind(...) qua
			if(columnsNumber <= This.MAX_COLUMNS_NUMBER)
				$("#dataset_size_exceeded_error").hide();
        });
    }
}

TableManager.prototype.deleteRow = function(removeGlyphicon) { //eliminiamo una riga
    var trToDelete = $(removeGlyphicon).parent().parent();
	var rowsNumber = this.getRows().length;
    //if (rowsNumber > 1) //controlliamo non sia l'unica riga, in Apriori però lo header è visto come una normale riga
        trToDelete.remove();
		if(rowsNumber <= this.MAX_COLUMNS_NUMBER)
			$("#dataset_size_exceeded_error").hide();
}

TableManager.prototype.addColumns = function(columnValues, shouldValidateData,boldText) {
	var columnsNumber = this.getHeaderRow().children().length - 1;//meno 1 perchè uno è glifo per cancellare la colonna e non va contato tra il numero di elementi per colonna
    
    var generateColumn = function(val) {
		if ( (columnValues && (columnsNumber > 1) && shouldValidateData) || (shouldValidateData && (!columnValues)))
			validateData();
        lastColumnIndex = this.getHeaderRow().last().find("th").eq(-2).attr("data-columnIndex");
        lastColumnIndex = lastColumnIndex ? parseInt(lastColumnIndex) : -1; //le colonne hanno un indice per rendere facile l'eliminazione
		var newColumn = this.copyColumnTemplate();
		$(newColumn).attr("data-columnIndex",++lastColumnIndex);
		$(newColumn).find("input.label_like").val(val);
		if(!boldText){
			$(newColumn).addClass("noBold");
			this.getHeaderRow().find("th").addClass("noBold");
		}
		this.getHeaderRow().last().find(".glyphicon.glyphicon-plus").first().before(newColumn);
		$("#" + this.tableID + ' input').prop("readonly", !this.WritePermission);
    }.bind(this);
	if(columnsNumber < this.MAX_COLUMNS_NUMBER){
		if (typeof columnValues === 'undefined') {
			generateColumn("");
			this.addMissingFields();
		} else {
			this.getHeaderRow().first().find('input').first().val(columnValues[0]);//siccome il primo input box dello header è già nel template
			for (var c = 1; c < columnValues.length; c++) {
				generateColumn(columnValues[c]);
			}
		}
	}
	else {
		$("#max_num").text(this.MAX_COLUMNS_NUMBER);
		$("#rows_columns").text('columns');
		$("#dataset_size_exceeded_error").show();
	}
}

//se viene aggiunta una colonna la funzione risistema tutte le righe aggiungendo i campi mancanti 
TableManager.prototype.addMissingFields = function(rowValuesArray, shouldValidateData) {
    var columnsNumber = this.getHeaderRow().children().length - 1;
	var generateField = this.generateField;
	
    this.getRows().each(function() { //(risistema la riga) aggiunge a ogni riga le input box nel caso sia stata aggiunta una colonna
        var a = $(this).children().length - 1;
        lastColumnIndex = $(this).children().eq(-2).attr("data-columnIndex");
        lastColumnIndex = lastColumnIndex ? parseInt(lastColumnIndex) : -1;
        for (var c = 0; c < columnsNumber - a; c++)
            $(this).children().last().before(generateField(++lastColumnIndex, ""));
        //$(this).children().last().before('<td data-columnIndex="'+(++lastColumnIndex)+'"><input class="label_like rigaEl form-control" type="text"></td>');
    });

    if (rowValuesArray) {
        this.getRows().find("input").each(function(index) {
            $(this).val(rowValuesArray[index] ? rowValuesArray[index] : '');
        });
    }
	$("#" + this.tableID + ' input').prop("readonly", !this.WritePermission);
}
//aggiunge una riga alla tabella
TableManager.prototype.addRow = function(rowValuesArray, shouldValidateData) {
	if (shouldValidateData)
		validateData();
	var columnsNumber = this.getHeaderRow().children().length - 1;
	if (columnsNumber > 0) { //è possibile aggiungere una riga vuota oppure una riga con dei valori che saranno espressi dentro rowValuesArray
		var rowsNumber = this.getRows().length;
		//+1 perchè una riga sarà eventualmente generata
		if( (rowsNumber+1) > this.MAX_ROWS_NUMBER){
			$("#max_num").text(this.MAX_ROWS_NUMBER);
			$("#rows_columns").text('rows');
			$("#dataset_size_exceeded_error").show();
		}
		else {
			rowValuesArray = rowValuesArray ? rowValuesArray : new Array(columnsNumber).fill(""); //se i dati mancano creiamo un array di stringhe vuote
			var lastColumnIndex = -1; //contatore per l'indice di colonna, le colonne sono numerate per rendere facile la cancellazione
			var currentRow = document.createElement('tr'); //creiamo un <tr> di classe riga e ci mettiamo dentro i vari <td> con eventuali valori, poi append
			currentRow = $(currentRow).addClass(this.getRowsClass());

			for (var c = 0; c < rowValuesArray.length; c++){ //aggiunge una riga nuova
				//currentRow.append('<td data-columnIndex='+(++lastColumnIndex)+'><input class="label_like rigaEl form-control" type="text" value="' + rowValuesArray[c] + '"></td>');
				currentRow.append(this.generateField(++lastColumnIndex, rowValuesArray[c]));
				if(this.getFieldsInRow(currentRow).length > (this.getHeaderRow().children('th').length - 1)){//meno 1 perchè uno è glifo per cancellare la colonna e non va contato tra il numero di elementi per colonna
					this.addColumns(undefined,undefined,false);
				}
			}
			currentRow.append(this.generateDeleteRowButton());
			$("#valuesContainer").append(currentRow);
		}
	}
	$("#" + this.tableID + ' input').prop("readonly", !this.WritePermission);
}
