var tableManager;//table manager si occupa di mostrare le tabelle dei dataset, potrebbe fornire anche la modifica delle tabelle (disabilitato)
var oldDataset;//serve per il predict, viene ripassato il vecchio dataset al server per ricalcolare il modello insieme al nuovo per il risultato finale
var currentAlgName;
function saveCallback(datasetType, datasetId,shouldValidateData) { //serve a aggiornare un dataset oppure a crearlo uno nuovo
    var currentDatasetModel = copyDatasetModel();
    currentDatasetModel.title = getTitleModal("myModal");
    if (currentDatasetModel.title !== "") {
        currentDatasetModel.type = datasetType;
        currentDatasetModel.data = validateData(shouldValidateData); //salvo i punti del dataset dentro il modal dialog
        currentDatasetModel.id = (typeof datasetId !== 'undefined') ? datasetId : Date.now(); //salviamo l'id del dataset
        //if (operationType === 'create') datasetContainer[currentDatasetModel.id] = currentDatasetModel;
        //else if (operationType === 'update') datasetContainer[datasetId] = currentDatasetModel;
		datasetManager.addDataset(currentDatasetModel.id,currentDatasetModel.type,currentDatasetModel);
        initPage(datasetType);
    }
}



$(document).ready(function() {
	tableManager = new TableManager("valuesContainer");
    $(document).off('click', '#available_dataset .single-dataset');
	currentAlgName = $("#algName").text().trim();//recupero il nome dell'algoritmo
	if (!embeddedPage){
		//controlliamo che sia stata richiesta direttamente una pagina specifica per un certo algoritmo
		//le pagine degli algoritmi possono essere richieste in modo specifico da una URL oppure possono essere inserite in una pagina già esistente dal JS
		initPage(getAlgType(currentAlgName));
		if(supportHistoryAPI())
			history.pushState({requestedRoute:currentRoute,algType:getAlgType(currentAlgName)},'Didactic Data Mining', currentRoute);
	}
	menuHighlightAlg(currentAlgName);//evidenziamo nel menu degli algoritmi quello corrente
    $(document).on('click', '#available_dataset .single-dataset', function() {
        var datasetId =$(this).attr('data-id');//estraiamo id del dataset cliccato dall'utente
		var datasetType =$(this).attr('data-type');
        //var datasetType = datasetManager.getDatasetByID(datasetId,datasetType).type;
        if (datasetType === "text" || datasetType === "text2") {
            var column_and_rows = datasetManager.getDatasetByID(datasetId,datasetType).data; //con id recuperiamo i punti associati al dataset
        }
        var template = datasetType === 'numeric' ? 'numeric_dataset_detail.html' : 'text_dataset_detail.html';
        var title = datasetManager.getDatasetByID(datasetId,datasetType).title;
        $.when(getTemplate('getTemplate', template)).then(function(data) {
            var newCallback = function() {
				var shouldValidateData = currentAlgName === TEXT_ALG_NAME.Apriori ? false : true;
                saveCallback(datasetType, datasetId,shouldValidateData);
            };
            showModal("myModal", title,data, newCallback,datasetId,"show");
            if (column_and_rows && column_and_rows.length > 0) {
                var columns = column_and_rows[0]; //il primo è per le colonne
                //aggiungiamo le colonne
				var boldText = currentAlgName === TEXT_ALG_NAME.Apriori ? false : true;
                tableManager.addColumns(columns, true,boldText);
                if (column_and_rows && (column_and_rows.length > 1)) {
                    var rows = column_and_rows.slice(1); //tutto il resto sono righe	
                    for (var c = 0; c < rows.length; c++) { //dopo aggiungiamo le righe
                        tableManager.addRow(rows[c], true);
                    }
                }
				//regola se l'utente dopo aver salvato può modificare di nuovo il dataset testuale (opzione di tableManager)
				var writePermission = true;//currentAlgName === TEXT_ALG_NAME.Apriori ? true : false;
				tableManager.setWritePermission(writePermission);
				tableManager.addMissingFields();
				//tableManager.hideEmptyFields();
				tableManager.show();
            }
        });
    });
    $('#step_by_step_switch').on('change', function() {
        imageNumber = 0; //reset contantore posizione immagine corrente (il template gestisce l'indice se sfora)
        //cancelliamo le altre immagini visualizzate se presenti con una piccola animazione
        $("#drawSurface > :not(#btn_control_image_flow)").fadeOut(function() {
            this.remove();
        });
    });
    registerActionOnEnterKeyPress($("#myModal"), function() {
        $("#save_button_modal").click();
    }); //premere invio nel modal è come premere il bottone salva
	
	currentAlgName = $("#algName").text().trim();
	if(currentAlgName === TEXT_ALG_NAME.Apriori)
		$("#randomDataset").removeClass('hidden');
	$('#datasetSelect').on('change',function(){updateTargetSelect($("#target_value"));});
	
	$("#datasetSelectPredict").selectpicker('hide');
	$('#datasetSelectPredict').on('change',function(){
		var id= this.value;
		var drawOptions = {
			datasetID : id,
			predict : true
		}
		draw(currentAlgName,drawOptions);
	});
	
	insertWikiLink(currentAlgName);
	if( /Android|webOS|iPhone|iPad|iPod|BlackBerry/i.test(navigator.userAgent) ) {
		$('.selectpicker').selectpicker('mobile');//da mobile la select usa viene gestita internamente dal browser
	}
});

function generateRandomDataset(numpoints, minvalue, maxvalue) {
	var algOptions;
	var datasetType = "text";
	var boldText = true;
	switch (currentAlgName){
	    case TEXT_ALG_NAME.Apriori:
			datasetType = "text2";
			boldText = false;//la tabella di apriori sono transazioni, non è una vera tabella con uno header, dobbia mostrarlo uguale alle altre righe
			path = '/' + TEXT_ALG_NAME.Apriori +'/generate_text_dataset';
			algOptions = options.Apriori;//andiamo a prendere l'opzione per l'algoritmo
			break;
	}
    $.get(path,{algOptions:JSON.stringify(algOptions)}, function(dataset) {
        var template = 'text_dataset_detail.html';
        $.when(getTemplate('getTemplate', template)).then(function(data) {
            var newCallback = function() {
                saveCallback(datasetType);
            };
            showModal("myModal", "", data, newCallback,undefined,"create");
			var column_and_rows = dataset;
			if (column_and_rows && column_and_rows.length > 0) {
				tableManager = new TableManager("valuesContainer");
				var columns = column_and_rows[0]; //il primo è per le colonne
				//aggiungiamo le colonne
				tableManager.addColumns(columns, true,boldText);
				if (column_and_rows && (column_and_rows.length > 1)) {
					var rows = column_and_rows.slice(1); //tutto il resto sono righe	
					for (var c = 0; c < rows.length; c++) { //dopo aggiungiamo le righe
						if (c === 0) tableManager.addMissingFields(rows[c], true);
						else tableManager.addRow(rows[c], true);
					}
				}
				tableManager.setWritePermission(true);
				tableManager.addMissingFields();
				//tableManager.hideEmptyFields();
				tableManager.show();
			}
        });
    });
}

function updateTargetSelect(targetInputText){
	if(currentAlgName === TEXT_ALG_NAME.Decision_Tree)$("#target_value_container").css('display','table');
	var datasetID = $('#datasetSelect').val();//prendiamo id del dataset selezionato se esiste
	if(datasetID !== ''){
		var string = '';	
		var datasetType = "text";
		if (currentAlgName === TEXT_ALG_NAME.Apriori){
				datasetType = "text2";
		}
		var datasetData = datasetManager.getDatasetByID(datasetID,datasetType).data;
		for(var c=0;c<datasetData[0].length;c++){//controlliamo se il target è valido, se fa parte degli header del dataset
			string += '<option val="'+datasetData[0][c]+'">'+datasetData[0][c]+'</option>';
		}
		$(targetInputText).html(string);
	}	
}

function validateData(shouldValidateData) {
    var data = [];
    $("#valuesContainer tr").each(function(index, el) {
        var currentRow = [];
        $(el).find("th,td").each(function(ind, element) {
            var inputEl = $(element).find("input");
            if (inputEl.length > 0) {
				if(shouldValidateData){
                if (inputEl.val()) {
                    removeError(inputEl);
                } else {
                    setError(inputEl, "Please fill in this field");
                }
				}
				var val = inputEl.val();
                if(val !== "")
					currentRow.push(val);
            }
        });
		if(currentRow.length > 0)
			data.push(currentRow);
    });
    return data;
}

function exportToCSV() {
    var string = CSV_COMMENT + "dataset_id,dataset_title,dataset_type (Decision Tree = text, Apriori = text2),dataset_rows\n";
	string += CSV_COMMENT + "ALL comments must be in a new line\n"
    var text_datasets = datasetManager.getDatasetByType('text');

    text_datasets.sort(sortDatasetById);
    //per ogni dataset creiamo una riga con titolo-typo-coordinata x- coordinata y
    //NB: se il dataset D ha N coordinate, allora nel CSV il dataset D sarà costituito da N righe
    for (var c = 0; c < text_datasets.length; c++) {
        var item = text_datasets[c];
        for (var d = 0; d < item.data.length; d++) {
            var colVal = item.data[d];
            string += item.id + ',' + item.title + ',' + item.type;
            for (var e = 0; e < colVal.length; e++) {
                string += ',' + colVal[e];
            }
            string += '\n';
        }
    }
    return string;
}
/*/
function readFromCSV(input) {
    const IGNORE_FIRST_LINE = false; //la prima riga potrebbe essere usata per descrivere i campi
    var files = input instanceof jQuery ? input[0].files : input.files; //se è un oggetto jQuery occorre accedere all'oggetto JS invece
    var text;
    var jsonFiles = {};
    var l = 0;
    var readFileFunc = function(theFile) {
        var text = reader.result;
        var lines = text.split('\n');
        for (var c = 0; c < lines.length; c++) {
            //ignoriamo il delimitatore di commento e forse la prima riga
            if (lines[c].substr(0, CSV_COMMENT.length) !== CSV_COMMENT && ((IGNORE_FIRST_LINE && c !== 0) || !IGNORE_FIRST_LINE)) {
                var CSVrow = lines[c];
                var CSVfields = CSVrow.split(',');
                if ( (CSVfields.length > 0) && (CSVfields[0].trim())) { //ci assicuriamo di parsare una riga corretta
                    var currentDatasetModel;
                    var id = CSVfields[0].trim();
                    currentDatasetModel = jsonFiles[id] ? jsonFiles[id] : copyDatasetModel();
                    currentDatasetModel.id = CSVfields[0].trim();//otteniamo info generiche quali id,titolo,typo dataset
                    currentDatasetModel.title = CSVfields[1].trim();
                    currentDatasetModel.type = CSVfields[2].trim();
                    if (currentDatasetModel.type === 'text') {
                        if (!(currentDatasetModel.data instanceof Array))
                            currentDatasetModel.data = [];
			
			var rowValues = [];
			for(var d=3;d<CSVfields.length;d++){
				//le altre righe ci stanno informazioni per le righe della tabella
				rowValues.push(CSVfields[d].replace('\r', '').trim());
			}
			currentDatasetModel.data.push(rowValues);
                        if (!jsonFiles[id]) //significa che è un elemento nuovo
                            jsonFiles[id] = currentDatasetModel;
                    }
			 else {
				bootbox.alert("You did not provide a textual dataset, it will be ignored");
				break;
			}
                }
            }
        } //sappiamo che abbiamo letto tutti i file in ingresso
        if (l == files.length) {
            updateavailableDatasetFromJSON(jsonFiles);
            injectMainPageTemplate(this, '/KMeans', 'text_dataset.html', undefined, {

                algName: 'K-Means',
                type: 'text'
            });
        }
    }
 
    for (l = 0; l < files.length; l++) {
        var reader = new FileReader();
	reader.onload = (readFileFunc);
        reader.readAsText(files[l]);
    }
    return jsonFiles;
}
/*/
function draw(algName,drawOptions) {
	var path = '';
	var algOptions;
	var datasetType = "text";
	switch (algName){
	case TEXT_ALG_NAME.Decision_Tree:
		path = '/'+TEXT_ALG_NAME.Decision_Tree+'/draw_dataset';
		algOptions = options.Decision_Tree;//andiamo a prendere l'opzione per l'algoritmo
		break;
	case TEXT_ALG_NAME.Apriori:
		path = '/'+TEXT_ALG_NAME.Apriori+'/draw_dataset';
		algOptions = options.Apriori;//andiamo a prendere l'opzione per l'algoritmo
		datasetType = "text2";
		break;	
	}
	var error = false;
	var datasetID = $('#datasetSelect').val();
	if(drawOptions && (typeof drawOptions.datasetID !== 'undefined'))
		datasetID = drawOptions.datasetID;
	var predict = false;
	if(drawOptions && (typeof drawOptions.predict !== 'undefined'))
		predict = drawOptions.predict;
	if( (typeof datasetID !== 'undefined') && datasetID !== ''){
		var targetText = $('#target_value').val().trim();
		if( targetText === '' ||hasError($('#target_value'))){
			error = true;
			bootbox.alert("Invalid target");
		}
		else {
		var datasetData = datasetManager.getDatasetByID(datasetID,datasetType).data;
		var convertedData = '';
		for(var x=0;x<datasetData.length;x++){
			for(var y=0;y<datasetData[x].length;y++){
				convertedData += datasetData[x][y];
				if(y < (datasetData[x].length -1))//non è l'ultimo valore dell'array
				convertedData += ',';
				else//siamo all'ultimo valore
				convertedData += '\n';
			}
		}
		if (datasetData.length == 0){
			error = true;
			bootbox.alert("This appear to be an empty dataset");
		}
		else {
			var points = JSON.stringify(datasetData); 
			$.LoadingOverlay("show");
			$.ajax({
				url:path, 
				data:{
				oldDataset : oldDataset ? oldDataset : '',
				text: convertedData,
				target: targetText,
				predict: predict,
				points:points,//per Apriori, è una matrice
				algOptions : JSON.stringify(algOptions,optionsStringifier)
			},
			success:function(result) {
				//se dobbiamo mostrare tutte le immagini una dopo l'altra tutte insieme
				clearSurface();
				$("#drawSurface #btn_control_image_flow").before(result);
				$("#btn_control_image_flow").addClass('hidden');//nascondiamo i controlli per le immagini
				if(algName === TEXT_ALG_NAME.Decision_Tree){
					oldDataset = convertedData;
					$("#datasetSelectPredict").selectpicker('show');//mostriamo la select per scegliere il secondo dataset
					var text=$("#calculus_string").text();
					var regex = /(Delta Gain:.+)/;//settiamo le regex
					var regex1 = /(-->.+)/;
					var regex2 = /(Root.+)/;//rimpiazziamo con degli span colorati
					text=text.replace(new RegExp(regex,'g'),'<code><span class="highlightText red">$1</span></code>');
					text=text.replace(new RegExp(regex1,'g'),'<code><span class="highlightText blue">$1</span></code>');
					text=text.replace(new RegExp(regex2,'g'),'<code><span class="highlightText green">$1</span></code>');
					$("#calculus_string").html(text);
					$("pre").each(function(index,el){//eliminiamo tutti i pre senza testo
						if(el.textContent.trim() === '')
							$(el).remove();
					});//togliamo 2 tab alla prima riga dei due pre
					$("#predict").text($("#predict").text().replace('\t\t',''));
					$("#evaluate").text($("#evaluate").text().replace('\t\t',''));
				}
				if(algName === TEXT_ALG_NAME.Apriori){
					var iterationRegex = /(Apriori.*Iteration.*)/;//settiamo le regex
					var notXRegex = /^([^<].+[^X])$/;
					var prunedElementsRegex = /^(.+?X)\s*$/;
					$("#imageContainer p").html(function(index,oldText){
						var text = oldText.trim();//rimuoviamo gli spazi inutili che possono complicare la logica delle regex
						text=text.replace(new RegExp(iterationRegex,'g'),'<span class="highlightText deepBlue">$1</span>');
						text=text.replace(new RegExp(notXRegex,'g'),'<span class="highlightText green">$1</span>');
						text=text.replace(new RegExp(prunedElementsRegex,'g'),'<span class="highlightText red">$1</span>');
						return text;
					});
				}
			},
			error:function(){
				clearSurface();
				bootbox.alert("An error occured during server communication");
			},
			complete:function(){$.LoadingOverlay("hide");}
			});
		}
		}
	}
	else {
		error = true;
		bootbox.alert("Please select a dataset");
	}
	if(error)
		clearSurface();
}



function showSettings(algName){
	var optionsList;
    switch (algName){
	    case TEXT_ALG_NAME.Decision_Tree:
			path = '/'+TEXT_ALG_NAME.Decision_Tree+'/options';
			break;
	    case TEXT_ALG_NAME.Apriori:
			path = '/'+TEXT_ALG_NAME.Apriori+'/options';
			break;
    }	
	var args = {algName:algName};
	var saveOptionsCallback = function(args) {//aggiorniamo le opzioni dell'algoritmo con i nuovi valori
		var currentDatasetOption;
		validateOptions(optionsList,true);//segna in rosso le opzioni non valide e riporta ai valori predefiniti i campi non validi
		if(args.algName === TEXT_ALG_NAME.Apriori){
			currentDatasetOption = options.Apriori;
			var num_transaction = $("#num_transaction").val();
			currentDatasetOption.num_transaction = num_transaction ? num_transaction : currentDatasetOption.num_transaction;
			var num_items = $("#num_items").val();
			currentDatasetOption.num_items = num_items ? num_items : currentDatasetOption.num_items;
			var min_len = $("#min_len").val();
			currentDatasetOption.min_len = min_len ? min_len : currentDatasetOption.min_len;
			var max_len = $("#max_len").val();
			currentDatasetOption.max_len = max_len ? max_len : currentDatasetOption.max_len;
			var sup_type = $("#sup_type").val();
			currentDatasetOption.sup_type = sup_type ? sup_type : currentDatasetOption.sup_type;
			var min_conf = $("#min_conf").val();
			currentDatasetOption.min_conf = min_conf ? min_conf : currentDatasetOption.min_conf;
			var min_sup = $("#min_sup").val();
			currentDatasetOption.min_sup = min_sup ? min_sup : currentDatasetOption.min_sup;
		}
		else if(args.algName === TEXT_ALG_NAME.Decision_Tree){
			currentDatasetOption = options.Decision_Tree;
			var fun_name = $("#fun_name").val();
			currentDatasetOption.fun_name = fun_name ? fun_name : currentDatasetOption.fun_name;
			var min_samples_split = Number($("#min_samples_split").val());
			currentDatasetOption.min_samples_split = min_samples_split ? min_samples_split : currentDatasetOption.min_samples_split;
			var min_samples_leaf = Number($("#min_samples_leaf").val());
			currentDatasetOption.min_samples_leaf = min_samples_leaf ? min_samples_leaf : currentDatasetOption.min_samples_leaf;
		}
		setCookie('options', JSON.stringify(options,optionsStringifier), 2);//mettiamo un cookie per salvare le opzioni, durata 2gg
		//args['dialog'].modal('hide');//chiudiamo il dialog
	}
					
	var f = function(dataReturned,args){//mostriamo i valori che abbiamo già nel menu delle opzioni
		var dialog = bootbox.dialog({
			title: 'Settings <span class="glyphicon glyphicon-cog grayColor"></span>',
			buttons: {
				close: {
					label: 'Close',
					className: "btn-danger"
				},
				confirm: {
					label: 'Save',
					className: "btn-info",
					callback: function(){
						saveOptionsCallback.call(this,args);
						unregisterEnterKeyPress($(".bootbox input"));
						$('option').off('change');
						}
				}
			},
			onEscape : true,
			backdrop: true,
			message: dataReturned
		});
		$(dialog).find('.modal-body').css('overflow-y', 'auto'); 
		$(dialog).find('.modal-body').css('max-height', $(window).height() * 0.7);
		
		var currentDatasetOption;
		if(args.algName === TEXT_ALG_NAME.Apriori){//mostriamo i valori che abbiamo già nel menu delle opzioni
			currentDatasetOption = options.Apriori;
			$("#num_transaction").val(options.Apriori.num_transaction);
			$("#num_items").val(options.Apriori.num_items);
			$("#min_len").val(options.Apriori.min_len);
			$("#max_len").val(options.Apriori.max_len);
			$("#sup_type").val(options.Apriori.sup_type);
			$("#min_conf").val(options.Apriori.min_conf);
			$("#min_sup").val(options.Apriori.min_sup);
		}
		else if(args.algName === TEXT_ALG_NAME.Decision_Tree){
			currentDatasetOption = options.Hierarchical;
			$("#fun_name").val(options.Decision_Tree.fun_name);
			$("#min_samples_split").val(options.Decision_Tree.min_samples_split);
			$("#min_samples_leaf").val(options.Decision_Tree.min_samples_leaf);
		}
		//battere invio su un campo input è come cliccare il pulsante per chiudere
		registerActionOnEnterKeyPress($(".bootbox input"),function(){$(".bootbox button[data-bb-handler='confirm']").click();},args);
		optionsList = [$("#num_transaction"),$("#num_items"),$("#min_len"),$("#max_len"),$("#sup_type"),$("#min_conf"),$("#min_sup"),$("#fun_name"),$("#min_samples_split"),$("#min_samples_leaf")];
		validateOptions(optionsList);
		$('.option').on('change',function(el){
			validateOptions(optionsList);//ogni volta che qualche input box cambia validiamo le opzioni e nel caso lo notifichiamo all'utente
		});
	}
	getTemplate(path,currentAlgName+'_options',args,f)//facciamo la richiesta di un template al termine esegue f con i dati del template restituiti
}

function validateOptions(HTMLOptions,normalize){
	HTMLOptions = HTMLOptions ? HTMLOptions : [];//delle opzioni da validare, se sono valide o meno, si aspetta il tag input da cui estrarre il valore min/max per il controllo
	for(var c=0;c<HTMLOptions.length;c++){
		var el = HTMLOptions[c];//prendiamo valori max/min se specificati in HTML, se ci sono confronto con il valore inserito dall'utente
		var min = $(el).attr('min');
		var max = $(el).attr('max');
		var currValue = $(el).val();
		if((typeof min !== 'undefined') && (typeof currValue !== 'undefined') && (Number(currValue) < Number(min))){
			setError($(el),'Current value lower than the minimum allowed');
			if(normalize)$(el).val(min);
		}
		if((typeof max !== 'undefined') && (typeof currValue !== 'undefined') && (Number(currValue) > Number(max))){
			setError($(el),'Current value greater than the maximum allowed');
			if(normalize)$(el).val(max);
		}
	}
}

function showInfo(algName){
	var algTitleDisplayed = "";
    switch (algName){
	    case TEXT_ALG_NAME.Decision_Tree:
			path = '/'+TEXT_ALG_NAME.Decision_Tree+'/info';
			algTitleDisplayed = TEXT_ALG_NAME.Decision_Tree;
			break;
	    case TEXT_ALG_NAME.Apriori:
			path = '/'+TEXT_ALG_NAME.Apriori+'/info';
			algTitleDisplayed = TEXT_ALG_NAME.Apriori;
			break;
    }
	var f = function(dataReturned){
		var dialog = bootbox.dialog({
			title: algTitleDisplayed + ' Info',
			message: dataReturned,
			buttons: {
				ok: {
					label: "Close",
					className: 'btn-info',
				}
			}
        });
		$(dialog).find('.modal-body').css('overflow-y', 'auto !important'); 
		$(dialog).find('.modal-body').css('max-height', $(window).height() * 0.7);
	}
	getTemplate(path,currentAlgName+'_info',undefined,f)//facciamo la richiesta di un template al termine esegue f con i dati del template restituiti
}
