const DATASET_TABLE_MAX_COLUMN_NUMBER = 2;
const CSV_COMMENT = '//';


var currentRoute;
var currentAlgName;
var templateLocalCache = {};
var embeddedPage = false;
var datasetManager = new DatasetManager();
const datasetModel = {
	id: '',
	type: '',
	title: '',
	data: {}
};

const NUMERIC_ALG_NAME = {
	KMeans : 'K-Means',//Cambiando i nomi qua poi vanno cambiati anche dalla parte del server; quindi nelle costanti del file .py che gestisce il server Flask
	Dbscan : 'Dbscan',
	Hierarchical : 'Hierarchical'
}

const TEXT_ALG_NAME = {
	Decision_Tree : 'Decision Tree',
	Apriori : 'Apriori',
}
/* non cancellare le opzioni sul numero di punti,valore min/max, se in futuro servissero queste opzioni basta scommentare (dai template
delle opzioni dei singoli algoritmi) le voci relative alle suddette opzioni per vedere funzionare il tutto. Al massimo vedere in js showSettings.
Se vengono aggiunte nuove opzioni bisogna aggiungere la gestione di esse a showSettings */
var options = {
	KMeans : {//diamo dei valori di default, cosi gli algoritmi funzionano lo stesso se l'utente non setta le sue opzioni
		centroid_index_c1 : 2,
		centroid_index_c2 : 5,
		min_value : 0,
		max_value : 10,
		num_points : 10
	},
	Dbscan : {
		min_value : 0,
		max_value : 10,
		num_points : 10,
		eps : 1.8,
		min_pts : 3
	},
	Hierarchical : {
		min_value : 0,
		max_value : 10,
		num_points : 10,
		link_criteria : 'min',
		use_distances : true
	},
	Decision_Tree : {
		fun_name : 'error',
		min_samples_split : 2,
		min_samples_leaf : 1
	},
	Apriori : {
		num_transaction : 10, 
		num_items : 6, 
		min_len : 2, 
		max_len : 4,
		min_sup : 0.3,
		sup_type : 'r',
		min_conf : 0.8
	}
}
/*/
INSERIMENTO MANUALE DI DATASET PREDEFINITI
/*/
var example1 = copyDatasetModel();
/*/l'ID dovrebbe esere il timestamp ma si può mettere anche un numero normale. LiD è formato dal tipo di dataset + un numero,
es: numeric1. Durante la fase di upload di un dataset all'utente viene chiesto di fornire un id (numerico) di quel dataset, l'utente
può inserire cosi lo stesso id numerico per due tipi diversi di dataset poichè verranno salvati in memoria con id = <tipo dataset> + <id fornito dall'utente>
/*/
example1.id=0;
example1.type='numeric';
example1.title='Dataset 1';
example1.data={x:['2','6','7','8','4','0','6','4','5','1'],y:['8','5','4','4','2','3','9','7','4','5']};
datasetManager.addDataset(example1.id,example1.type,example1);

var example2 = copyDatasetModel();
example2.id=1;
example2.type='numeric';
example2.title='Dataset 2';
example2.data={x:['2','7','7','0','4','0','6','0','3','1'],y:['8','5','4','4','2','5','8','7','7','9']};
datasetManager.addDataset(example2.id,example2.type,example2);

var example3 = copyDatasetModel();
example3.id=2;
example3.type='numeric';
example3.title='Dataset 3';
example3.data={x:['7','1','7','8','4','9','4','8','9','2'],y:['8','5','4','4','2','3','9','7','4','5']};
datasetManager.addDataset(example3.id,example3.type,example3);

var example4 = copyDatasetModel();
example4.id=0;
example4.type='text';
example4.title='Training 1';
example4.data=[
['State','Contract','Sex','ServiceCalls','Minutes','Churn'],
['Italy','Classic','F','more10','50','YES'],
['German','Travel','M','less10','60','NO'],
['Italy','Travel','M','more10','70','YES'],
['Italy','Young','F','less10','80','NO'],
['German','Travel','F','more10','90','NO'],
['German','Classic','M','more10','100','YES'],
['German','Classic','M','less10','110','YES'],
['German','Young','F','less10','50','YES'],
['German','Young','M','more10','150','NO'],
['German','Travel','F','less10','100', 'NO']
];
datasetManager.addDataset(example4.id,example4.type,example4);

var example5 = copyDatasetModel();
example5.id=1;
example5.type='text';
example5.title='Test 1';
example5.data=[
['State', 'Contract', 'Sex', 'ServiceCalls', 'Minutes', 'Churn'],
['Italy', 'Classic', 'F', 'more10', '30', 'YES'],
['German', 'Travel', 'M', 'less10', '60', 'NO'],
['Italy', 'Travel', 'F', 'more10', '100', 'NO'],
['Italy', 'Travel', 'M', 'less10', '100', 'YES']];
datasetManager.addDataset(example5.id,example5.type,example5);

var example6 = copyDatasetModel();
example6.id=1;
example6.type='text2';
example6.title='Dataset 1';
example6.data=[
	["B", "C", "D", "F"],
	["D", "E"],
	["A", "E"],
	["D", "E", "F"],
	["A", "B", "D", "F"],
	["A", "E"],
	["B", "D", "E"],
	["B", "E"],
	["A", "E"]];
datasetManager.addDataset(example6.id,example6.type,example6);

var example7 = copyDatasetModel();
example7.id=2;
example7.type='text2';
example7.title='Dataset 2';
example7.data=[
	['C', 'F'],
	['B', 'C', 'D', 'F'],
	['B', 'C', 'D', 'E'],
	['A', 'B', 'C', 'F'],
	['A', 'B', 'E'],
	['C', 'D', 'E', 'F'],
	['D', 'F'],
	['A', 'D'],
	['C', 'D', 'E', 'F'],
	['D', 'E']]
datasetManager.addDataset(example7.id,example7.type,example7);

function getAlgOptions(algName){
	var option;
	switch(algName){
		case NUMERIC_ALG_NAME.KMeans:
			option = options.KMeans
			break;
		case NUMERIC_ALG_NAME.Dbscan:
			option = options.Dbscan
			break;
		case NUMERIC_ALG_NAME.Hierarchical:
			option = options.Hierarchical
			break;
		case TEXT_ALG_NAME.Apriori:
			option = options.Apriori
			break;
		case TEXT_ALG_NAME.Decision_Tree:
			option = options.Decision_Tree
			break;
	}
	return option;
}
//extend jQuery with a function to test if an element is visible in viewport with a vertical/horizontal approximation
$.fn.isOnScreen = function(x, y){
    
    if(x == null || typeof x == 'undefined') x = 1;
    if(y == null || typeof y == 'undefined') y = 1;
    
    var win = $(window);
    
    var viewport = {
        top : win.scrollTop(),
        left : win.scrollLeft()
    };
    viewport.right = viewport.left + win.width();
    viewport.bottom = viewport.top + win.height();
    
    var height = this.outerHeight();
    var width = this.outerWidth();
 
    if(!width || !height){
        return false;
    }
    
    var bounds = this.offset();
    bounds.right = bounds.left + width;
    bounds.bottom = bounds.top + height;
    
    var visible = (!(viewport.right < bounds.left || viewport.left > bounds.right || viewport.bottom < bounds.top || viewport.top > bounds.bottom));
    
    if(!visible){
        return false;   
    }
    
    var deltas = {
        top : Math.min( 1, ( bounds.bottom - viewport.top ) / height),
        bottom : Math.min(1, ( viewport.bottom - bounds.top ) / height),
        left : Math.min(1, ( bounds.right - viewport.left ) / width),
        right : Math.min(1, ( viewport.right - bounds.left ) / width)
    };
    
    return (deltas.left * deltas.right) >= x && (deltas.top * deltas.bottom) >= y;
    
};

//callback da usare con JSON.stringify occupa di trasformare in stringa le opzioni, può escludere dei campi dai cookie da salvare in locale
function optionsStringifier(key,value){
	if(key === 'key_to_exclude') return undefined;
	else return value;
}
/*/
	Funzione riservata a inserire nella pagine una delle due pagine HTML (numeric_dataset.html/text_dataset.html)
	in base al tipo di algoritmo fornito come argomento
/*/

function supportHistoryAPI(){
	return window.history && window.history.pushState;
}

function injectMainPageTemplate(element, route, container, args) {
	//se non è dato diamo un container di default
	args = args ? args : {};
	args["requestedRoute"] = route;
	embeddedPage = true;
	args['embedded'] = embeddedPage;
	container = container ? container : '.content .subContent';
	var loadingTimeout = setTimeout(function() {
       $.LoadingOverlay("show");
    }, 500);
	return $.ajax({
		url: route,
		data: {
		args: JSON.stringify(args)
		},
		complete: function(){
				clearTimeout(loadingTimeout);
				$.LoadingOverlay("hide");
		},
		success: function(data) {//topBtn è il FAB per tornare in cima alla pagina	
					if(!args || (typeof args.preserveHistory === 'undefined') || !args.preserveHistory){//se args ha un parametro preserveHistory = true allora non alteriamo la storia
						if(supportHistoryAPI())
							history.pushState(args,'Didactic Data Mining', route);
					}
					var datasetTypeArgSupplied = '';
					if(args && (typeof args.algType !== 'undefined')){
						datasetTypeArgSupplied = args.algType;
						datasetTypeArgSupplied === 'numeric' ? getScript('static/numeric-dataset.js') : getScript('static/text-dataset.js');
						$.getScript("static/jquery.custom-file-input.js");
					}
					$(container +' :not(#topBtn,#topBtn>span)').remove();
					$(container).prepend(data).hide().fadeIn();//piccola animazione per inserire il contenuto nella pagina
					currentRoute = route;
					datasetTypeArgSupplied = (args && (typeof args.algType !== 'undefined') ) ? args.algType : '';
					initPage(datasetTypeArgSupplied);
		},
		error: function(){
			menuHighlightAlg("");
			bootbox.alert("An error occured during server communication");
		}
	});
}

//ottiene un template e lo salva nella variabile globale templateContainer
function getTemplate(route, templateName, args, callback) {
	if(!templateLocalCache || (typeof templateLocalCache[templateName] === 'undefined')){
		var loadingTimeout = setTimeout(function() {
		   $.LoadingOverlay("show");
		}, 500);
		return $.ajax({
				url:route, 
				data:{
					templateName: templateName,
					args: JSON.stringify(args)
				},
				complete: function(){
					clearTimeout(loadingTimeout);
					$.LoadingOverlay("hide");
				},
				success: function(data) {
					templateLocalCache[templateName] = data;
					$.LoadingOverlay("hide");
					if( (typeof callback !== 'undefined') && callback)//se è data una callback lanciamola
						callback.call(this,data,args);
				},
				error: function(){
					bootbox.alert("An error occured during server communication");
				}	
		});
	}
	else {//nel caso in cui abbiamo già salvato su disco il template
		var data = templateLocalCache[templateName];
		if( (typeof callback !== 'undefined') && callback)//se è data una callback lanciamola
						callback.call(this,data,args);
		var myDeferred = $.Deferred();
		return myDeferred.resolve(data);
	}
}

function getScript(url){
	return $.getScript(url);
}

function sortDatasetAlphabetically(a, b) {
	return a.title.localeCompare(b.title);
}

function sortDatasetById(a, b) {
	return a.id < b.id ? -1 : (a.id > b.id ? 1 : 0);
}

//riempie una select di valori
function fillSelect(select, data) {
	var oldVal = $(select).val();//nel caso esista già un valore rimettiamo quello dopo aver aggiornato la select
	$(select).empty();
	var datasetNameCount = {};
	$(data).each(function(index, item) {
		datasetNameCount[item.title] = datasetNameCount[item.title] ? ++datasetNameCount[item.title] : 1;
	});
	$(data).each(function(index, item) {
		var idString = '';
		if(datasetNameCount[item.title] > 1){
			var stringID = String(item.id);
			var idLastChracters = stringID.substr(stringID.length - 5);
			idString = ' (ID: ...' + idLastChracters + ')';
		}
		$(select).append('<option data-id="' + item.id + '" value="' + item.id + '">' + item.title + idString + '</option>');
	});
	$(select).selectpicker('refresh');
	$(select).selectpicker('val',oldVal);
}


function getModalTitleElement(modalID) {
	return $("#" + modalID + " .modal-title");
}

function getTitleModal(modalID) {
	return getModalTitleElement(modalID).val();
}

function setTitleModal(modalID, title, placeHolder) {
	title = title ? title : "";
	placeHolder = placeHolder ? placeHolder : "";
	getModalTitleElement(modalID).val(title);
	getModalTitleElement(modalID).attr("placeHolder", placeHolder);
}

function setError(element, tooltipTitle) {
	$(element).parent().addClass('has-error');
	$(element).parent().attr('data-toggle', "tooltip");
	$(element).parent().attr('title', tooltipTitle);
	$(element).parent().attr('data-original-title', tooltipTitle);
	$(element).parent().tooltip({placement: 'auto top'});
}

function removeError(element){
	$(element).parent().removeClass('has-error');
	$(element).parent().attr('data-toggle', "");
	$(element).parent().attr('title', "");
	$(element).parent().attr('data-original-title', "");
	$(element).parent().tooltip('hide');
}

function hasError(element){
	return $(element).parent().hasClass('has-error');	
}

function showHelpPage(){
	$.when(injectMainPageTemplate(this, '/Help',undefined,{algType:'help'})).then(function(){
		$("#footer").empty();
		menuHighlightAlg('Help');
	});
}

function showModal(modalID, datasetTitle,data,callback,datasetId,operationType) {
	//settiamo il titolo
	setTitleModal(modalID, datasetTitle, "Dataset name");
	//settiamo il messaggio
	$("#" + modalID + " .modal-body").html(data);
	$("#" + modalID).modal({
		backdrop: true,
		keyboard: true
	});
	var id = (typeof datasetId !== 'undefined') ? "Id: " + datasetId : "";
	$("#show_dataset_id").text(id)
	$("#dataset_size_exceeded_error").hide();//nascondiamo il mesasggio di errore del dialog
	//settiamo il listener per il pulsante per salvare
	$("#" + modalID + ' .modal-footer button').on('click', function(e) {
		if(getTitleModal(modalID).trim() === ""){
			$("#generic_error").show();
			$("#generic_error .errorMessage").text("Please provide title");
			setTimeout(function(){
				$("#generic_error").fadeOut('normal',function(){
					$("#generic_error .errorMessage").text('');
					$(this).hide();
				});
			},2000);
			return false;
		}
		else {
			$("#generic_error").hide();//reset
			$("#generic_error .errorMessage").text("");
			callback();
			return true;
		}
		
	});
	//alla chiusura del modal togliamo i listener
	$("#" + modalID).on('hidden.bs.modal', function() {
		$("#" + modalID + ' .modal-footer button').off("click");
		$("#" + modalID).off('shown.bs.modal');
	});
	if(operationType && operationType === "create"){
		$("#operationTypeEdit").hide();
		$("#operationTypeShow").hide();
		$("#operationTypeCreate").show();
		$("#" + modalID).one('shown.bs.modal', function() {//one registra il listener solo una volta, quando viene creato un dataset la cosa principale è il titolo
			getModalTitleElement(modalID).focus();
		});
	}
	if(operationType && operationType === "edit"){
		$("#operationTypeEdit").show();
		$("#operationTypeShow").hide();
		$("#operationTypeCreate").hide();
	}
	if(operationType && operationType === "show"){
		$("#operationTypeEdit").hide();
		$("#operationTypeShow").show();
		$("#operationTypeCreate").hide();
	}
	
	$('.modal').find('.modal-body').css('overflow-y', 'auto'); 
	$('.modal').find('.modal-body').css('max-height', $(window).height() * 0.7);
	
}

function setDownloadButton(downloadButton,fileTitle, data) {
	var blob = new Blob([data], {
type: "text/csv"
	});
	var url = URL.createObjectURL(blob);
	var a = document.createElement('a');
	a.id = "blob_link";
	a.download = fileTitle;
	a.href = url;
	$("body").append(a);//creaiamo una ancora con un link e dopo averla cliccata la eliminiamo
	a.click();
	$("#blob_link").remove();
}
var elementPosition;
function scrollFunction(threshold) {
	//Controlla il pulsante per tornare in cima
	if ($(window).scrollTop() > threshold) {
		$("#topBtn").fadeIn("fast");
	} else {
		$("#topBtn").fadeOut("fast");
	}
	
	//Controlla il menu per dell'algoritmo che segue l'utente mentre scrolla in basso
	if(typeof elementPosition !== 'undefined'){
		if($(window).scrollTop() > (elementPosition.top + 50)){
				$("#drawSurface").addClass("paddingTop");
				//algBox e drawSurface sono fratelli, se algBox diventa position fixed, bisogna che ci sia un riempimento dentro drawSurface per compensare il buco
				//lascia algBox dentro il loro padre, in questo modo lo scrolling non ha nessuno scatto ed è piacevole per l'utente 
				$("#drawSurface").css("margin-top",$("#algBox").height());
				var parent = $("#algBox").parent();
				$("#algBox").css({
					position:"fixed",
					top : 0,
					"background-color": "rgba(127, 208, 255, 0.95)",
					width: parent.width(),
				});
		}
		else{
				$("#algBox").css({
					position:"static",
					"background-color": "initial",
					width: "initial"
				});
				$("#drawSurface").css("margin-top",15);
				$("#drawSurface").removeClass("paddingTop");
		}
	}
	else 
		elementPosition = $('#algBox').offset(); 
}

// When the user clicks on the button, scroll to the top of the document
function topButtonFunction() {
	$('html,body').animate({ scrollTop: 0 }, 400);
}

function getAlgType(algName){
	algType = "";
	switch(algName){
		case NUMERIC_ALG_NAME.KMeans:
		case NUMERIC_ALG_NAME.Dbscan:
		case TEXT_ALG_NAME.Hierarchical:
			algType = "numeric";
			break;
		case TEXT_ALG_NAME.Decision_Tree:
			algType = "text";
			break;
		case TEXT_ALG_NAME.Apriori:
			algType = "text2";
			break;
		default:
			algType = ""
	}
	return algType;
}

function menuHighlightAlg(algName){//evidenzia un algoritmo nel menù di scelta degli algoritmi
	if( typeof algName !== 'undefined'){
		$(".menu .btn-group button").each(function(index,el){
			if (algName === $(el).text()){
				$(el).addClass('active');
			}
			else {
				$(el).removeClass('active');
				$(el).blur();
			}
		});
	}
}

function closeAllModal (){
	var allModalsClosed = false;
	var myDeferred = $.Deferred();
	bootbox.hideAll();
	if ($('#myModal').is(':visible')){
		$('#myModal').modal('hide');
		$('#myModal').on("hidden.bs.modal",function(){//aspettiamo che il modal di bootstrap si chiuda
			allModalsClosed = true;
		});
	} else allModalsClosed = true;
	return allModalsClosed ? myDeferred.resolve() : myDeferred.promise();
}
			
$(document).ready(function() {
	if(supportHistoryAPI()){
		$(window).on("popstate", function(e) {
			var state = e.originalEvent.state;
			if(state && (typeof state["requestedRoute"] !== 'undefined') && (typeof state["algType"] !== 'undefined')){		
				//aspettiamo che tutti i modal siano chiusi per caricare la pagina precedente
				$.when(closeAllModal()).then(function(){
					injectMainPageTemplate(this,state["requestedRoute"],undefined,{algType:state["algType"],preserveHistory:true});
					if(state['algType'] === 'help')
						menuHighlightAlg('Help');
				});
			}
		});
	}
	currentRoute = window.location.href;
	//la url deve essere quella base <fqdn>[:<numero porta>], non deve avere help/kmeans ecc perchè sono url specifiche quelle
	var res = currentRoute.match(/help|k-means|dbscan|hierarchical|(?:decision.*?tree)|(?:classification\s*tree)|apriori$/i);
	if(!res || res.length == 0){
		//se l'utente non richiede direttamente l'algoritmo tramite url specifica mostriamo il menu di aiuto come prima pagina, poi l'utente sceglie lui l'algoritmo
		showHelpPage();
	}
	//se l'utente accede alla url diretta della pagina di aiuto voglio evidenziare sul menu la sezione corrente. Per gli algoritmi viene fatto nei relativi script ma la pagina di aiuto n
	//non fa parte degli algoritmi, è una cosa a se
	res = currentRoute.match(/help$/i);
	if(res && res.length > 0){
		menuHighlightAlg('Help');
		if(supportHistoryAPI())
			history.pushState({requestedRoute:currentRoute,algType:'help'},'Didactic Data Mining', currentRoute);
	}
	// When the user scrolls down 20px from the top of the document, show the button
	var threshold = 200;
	var didScroll = true;
	window.onscroll = function() {
		didScroll = true;
		//scrollFunction(threshold,didScroll);
	};
	setInterval(function(){//on scroll viene chiamato un numero elevato di volte, limitiamo esecuzione di funzioni
			if(didScroll){
				didScroll = false;
				scrollFunction(threshold)
			}
		},250);
	//evidenziamo l'algoritmo corrente nel menu di scelta
	$(".menu .btn-group").on('click','button',function(){
		$(this).siblings().removeClass('active');
		$(this).addClass('active');
	});
	//se si clicca sul titolo si va alla home page -> nessun algoritmo selezionato
	$("#title").on('click',function(){
		$(".menu .btn-group button").siblings().removeClass('active');
	});//recperiamo i cookie e li usiamo se ci sono
	cResult = getCookie('options');
	options = cResult ? JSON.parse(cResult) : options;
});

function getWikiLink(algName){
	algName = algName ? algName : "";
	var link = '';
	switch (algName){
	    case NUMERIC_ALG_NAME.KMeans:
			link = 'https://en.wikipedia.org/wiki/K-means_clustering';
			currentRoute = currentRoute ? currentRoute : '/'+NUMERIC_ALG_NAME.KMeans;
			break;
	    case NUMERIC_ALG_NAME.Dbscan:
			link = 'https://en.wikipedia.org/wiki/DBSCAN';
			currentRoute = currentRoute ? currentRoute : '/'+NUMERIC_ALG_NAME.Dbscan;
			break;
	    case NUMERIC_ALG_NAME.Hierarchical:
			link = 'https://en.wikipedia.org/wiki/Hierarchical_clustering';
			currentRoute = currentRoute ? currentRoute : '/'+NUMERIC_ALG_NAME.Hierarchical;
			break;
		case TEXT_ALG_NAME.Decision_Tree:
			link = 'https://en.wikipedia.org/wiki/Decision_tree_learning';
			break;
	    case TEXT_ALG_NAME.Apriori:
			link = 'https://en.wikipedia.org/wiki/Apriori_algorithm';
			break;	
    }
	return {link:link,currentRoute:currentRoute}
}

function clearFooter(){
	$("#footer").empty();
}

function insertWikiLink(algName,whereToInsertSelector){
	var link = getWikiLink(algName).link;
	whereToInsertSelector = whereToInsertSelector ? whereToInsertSelector : "#footer";
	if(link)
		$(whereToInsertSelector).html('<a target="_blank" href="'+link+'">Wiki: '+algName+'</a>');
	else
		clearFooter();
}

function getImage(route, imageName, callback) {
	return $.get(route, {
filename: imageName
	}, function(data) {
		callback.apply(this, [data]);
	});
}

//aggiunge un dataset, prima chiama il template per i dettagli del dataset numerico/testuale e poi visualizza il Dialog 
function add_dataset(type) {
	var msg;
	if(typeof type === 'undefined'){
		type = getAlgType(currentAlgName);
	}
	template = type === 'numeric' ? 'numeric_dataset_detail.html' : 'text_dataset_detail.html';
	$.when(getTemplate('getTemplate', template)).then(function(data) {
		var newCallback = function() {
			saveCallback(type);
		};
		showModal("myModal", "",data, newCallback,undefined,"create"); //nel dialog inserisce il template ottenuto in precedenza
		if(typeof tableManager !== 'undefined')
			tableManager.setWritePermission(true);
	});
}

function deleteTableEntry(caller) {
	var datasetType = $(caller).siblings("a.single-dataset").attr("data-type");
	var entryID = $(caller).siblings("a.single-dataset").attr("data-id");
	var tdContainer = $(caller).parents("td");
	var trContainer = $(tdContainer).parent();
	//se nella riga c'è solo l'elemento da eliminare, allora possiamo rimuovere la riga
	if (trContainer.children().length == 1) {
		$(trContainer).remove();
	} else {
		$(tdContainer).remove();
	}
	//rimuoviamo il dataset
	datasetManager.deleteDatasetByID(entryID,datasetType);
	//il primo <tr> è per l'header => se c'è solo lo header
	if ($("#available_dataset tr").length == 1) {
		$("#available_dataset tbody tr").remove();
		$("#available_dataset thead").remove();
		$("div.single-dataset-empty.alert.alert-danger").show("fast");
	}
	initPage(datasetType);
}

function initPage(datasetType) {
	datasetType = datasetType ? datasetType : 'numeric';
	$("#available_dataset thead").remove();
	$("#available_dataset tbody tr").remove();
	$("#dataset_size_exceeded_error").hide();//rimuoviamo nel dialog il messaggio di errore di troppi punti inseriti
	
	var dataset = datasetManager.sortDatasetAlphabetically(datasetType);//datasetManager.getDatasetByType(datasetType);
	//dataset.sort(sortDatasetAlphabetically);
	var string = "";
	$(dataset).each(function(index, val) {
		if (index % DATASET_TABLE_MAX_COLUMN_NUMBER == 0) {
			string += '<tr>';
		}
		string += '<td><a class="single-dataset" data-type="' + datasetType + '"data-id="' + val.id + '">' +
		val.title + '</a><span onclick="deleteTableEntry(this);"' +
		'class="glyphicon glyphicon-remove available_dataset_remove_button"></span></td>';
		if ((index === dataset.length - 1) || (((index + DATASET_TABLE_MAX_COLUMN_NUMBER) % DATASET_TABLE_MAX_COLUMN_NUMBER) === DATASET_TABLE_MAX_COLUMN_NUMBER - 1)) {
			string += '</tr>';
		}
	});
	if (dataset.length > 0) {
		$("#available_dataset tbody").before("<thead><tr><th colspan='" + DATASET_TABLE_MAX_COLUMN_NUMBER + "'>Available datasets</th></tr></thead>");
		$("div.single-dataset-empty.alert.alert-danger").hide();
		$("#available_dataset tbody").append(string);
		fillSelect('#datasetSelect', dataset);
		fillSelect('#datasetSelectPredict', dataset);
		//si nasconde il pulsante per disegnare => nessun dataset disponibile
		$("#drawOptions").removeClass("hidden");
		$("#datasetSelect").selectpicker('show');
	} else {
		$("#drawOptions").addClass("hidden");
		$("#datasetSelect").selectpicker('hide');
		$("#datasetSelectPredict").selectpicker('hide');
		clearSurface();
		$("div.single-dataset-empty.alert.alert-danger").show();
	}
}

function copyDatasetModel(dataset_Model) {
	dataset_Model = dataset_Model ? dataset_Model : datasetModel;
	return $.extend(true, {}, dataset_Model);
}

function updateavailableDatasetFromJSON(datasetManager2) {
	datasetManager2 = datasetManager2 ? datasetManager2 : new DatasetManager();
	//dal JSON estraiamo ciò che ci occorre e lo salviamo
	datasetOperationPending = [];//elenco di dataset per cui è richiesta l'azione dell'utente
	for (type in datasetManager2.getDatasetContainer()) {
		for(id in datasetManager2.getDatasetContainer()[type]){
			var tempDatasetModel = copyDatasetModel();
			var currentDataset = datasetManager2.getDatasetContainer()[type][id];
			tempDatasetModel.title = currentDataset.title;
			tempDatasetModel.type = currentDataset.type;
			tempDatasetModel.data = currentDataset.data;
			//l'id è il timestamp della creazione del dataset
			tempDatasetModel.id = currentDataset.id;
			//datasetContainer[currentDataset.id] = tempDatasetModel;
			//if(currentDataset.id in datasetContainer)
			if(datasetManager.getDatasetByID(currentDataset.id,currentDataset.type))
				datasetOperationPending.push(tempDatasetModel);
			else
				datasetManager.addDataset(currentDataset.id,currentDataset.type,tempDatasetModel);
		}
	}

	var launchPrompt = function(index,datasetOperationPending){
		//lanciamo un prompt di conferma come una promessa (jQuery Deferred) per l'utente, vuole sovrascrivere o no il dataset?
		var myDeferred = $.Deferred();
		var currentdatasetOperationPending = datasetOperationPending[index];
		bootbox.confirm({
			title: "Same dataset ID clashes with another dataset",
			message: "<h4>Do you want to overwrite the existing dataset?</h4>"+
					"<p>Dataset title: "+currentdatasetOperationPending.title+"</p><p>"+
					"Dataset id: "+currentdatasetOperationPending.id+"</p>",
			buttons: {
				cancel: {
					label: 'Cancel'
				},
				confirm: {
					label: 'Overwrite <i class="glyphicon glyphicon-pencil"></i>',
					className: 'btn-danger'
				}
			},
			callback: function (result) {
				if(result){
					datasetManager.addDataset(currentdatasetOperationPending.id,currentdatasetOperationPending.type,currentdatasetOperationPending);
					//datasetContainer[currentdatasetOperationPending.id] = currentdatasetOperationPending;
				}
				myDeferred.resolve();
			}
		});
		return myDeferred.promise();
	}
	
	var promiseLauncher = function(index,datasetOperationPending){
		//quando l'utente ha fatto la sua scelta possiamo mostrare il prompt successivo se ci sono ancora azioni che richiedono l'internvento dell'utente 
		if (datasetOperationPending && index < datasetOperationPending.length){
			$.when(launchPrompt(index,datasetOperationPending)).then(function(){
				setTimeout(function(){//aspettiamo un poco di tempo per rendere i futuri prompt "meno aggresivi" alla vista dell'utente
					promiseLauncher(index+1,datasetOperationPending);
				},100);
			});
		}
	}
	
	promiseLauncher(0,datasetOperationPending);//iniziamo a lanciare la prima promessa (non promise ma jQuery Deferred) che verrà risolta quando l'utente sceglie cosa fare
}

function registerActionOnEnterKeyPress(el,callback,callbackArgs){
	$(el).keypress(function(e){
		if(e.keyCode==13)
		callback.call(e.target,callbackArgs);
	});
}

function unregisterEnterKeyPress(el){$(el).off( "keypress" );}

function clearSurface(){
	$("#imageContainer").fadeOut('slow',function(){$(this).remove();});
	$("#datasetSelectPredict").selectpicker('hide');//nascondo select
	$("#target_value_container").hide();
}

function readFromCSV(input) {
	const IGNORE_FIRST_LINE = false; //la prima riga potrebbe essere usata per descrivere i campi
	var files = input instanceof jQuery ? input[0].files : input.files; //se è un oggetto jQuery occorre accedere all'oggetto JS invece
	var text;
	var datasetManager2 = new DatasetManager();
	var l = 0;
	var linesNum = 0;
	var currentLine = 1;

	var readFileTextDatasetFunc = function(line,lineNumber,datasetManager2) {//parder per dataset testuali
		//ignoriamo il delimitatore di commento e forse la prima riga
		if (line.substr(0, CSV_COMMENT.length) !== CSV_COMMENT && ((IGNORE_FIRST_LINE && lineNumber !== 0) || !IGNORE_FIRST_LINE)) {
			var CSVrow = line;
			if (CSVrow.trim()){
				var CSVfields = CSVrow.split(',');
				if ( (CSVfields.length > 3) && (CSVfields[0].trim())) { //ci assicuriamo di parsare una riga corretta
					var currentDatasetModel;
					var id = CSVfields[0].trim();
					id = id ? id : Date.now();//se l'id non viene trovato/ricosciuto come valido lo daimo noi l'id
					var type = CSVfields[2].trim().toLowerCase();
					if (type == 'text' || type == 'text2') {
						//if (id.substr(0,"text".length) !== "text")//se inizia con "text" l'id
							//id = type + "_" + id;
						currentDatasetModel = datasetManager2.getDatasetByID(id,type) ? datasetManager2.getDatasetByID(id,type) : copyDatasetModel();
						//otteniamo info generiche quali id,titolo,typo dataset
						currentDatasetModel.title = CSVfields[1].trim();
						currentDatasetModel.type = type;
						currentDatasetModel.id = id;
						if (!(currentDatasetModel.data instanceof Array))
						currentDatasetModel.data = [];
						var rowValues = [];
						for(var d=3;d<CSVfields.length;d++){
							//le altre righe ci stanno informazioni per le righe della tabella
							rowValues.push(CSVfields[d].replace('\r', '').trim());
						}
						currentDatasetModel.data.push(rowValues);
						if (! datasetManager2.getDatasetByID(id,type)) //significa che è un elemento nuovo
						datasetManager2.addDataset(id,type,currentDatasetModel);
					}
					else {
						bootbox.alert("You did not provide a textual dataset, it will be ignored");
					}
				}else {
					bootbox.alert("<strong>" + CSVrow + "</strong>" + " Invalid row");
				}
			}
		}
	}


	var readFileNumericDatasetFunc = function(line,lineNumber,datasetManager2){//parser per dataset numerici
		const NUMBER_OF_COLUMNS = 5;
		if (line.substr(0, CSV_COMMENT.length) !== CSV_COMMENT && ((IGNORE_FIRST_LINE && lineNumber !== 0) || !IGNORE_FIRST_LINE)) {
			var CSVrow = line;
			if (CSVrow.trim()){
				var CSVfields = CSVrow.split(',');
				if ((CSVfields.length > 3) && (CSVfields.length === NUMBER_OF_COLUMNS) && (CSVfields[0].trim())) {//ci assicuriamo di parsare una riga corretta
					var currentDatasetModel;
					var id = CSVfields[0].trim();
					id = id ? id : Date.now();//se l'id non viene trovato/ricosciuto come valido lo daimo noi l'id
					var type = CSVfields[2].trim().toLowerCase();
					if(type == 'numeric'){
						//if (id.substr(0,"numeric".length) !== "numeric")//se inizia con "numeric" l'id
							//id = type + "_" + id;
						currentDatasetModel = datasetManager2.getDatasetByID(id,type) ? datasetManager2.getDatasetByID(id,type) : copyDatasetModel();
						currentDatasetModel.title = CSVfields[1].trim();
						currentDatasetModel.type = type;
						currentDatasetModel.id = id;
						if (typeof currentDatasetModel.data.x == 'undefined')
						currentDatasetModel.data.x = [];
						if (typeof currentDatasetModel.data.y == 'undefined')
						currentDatasetModel.data.y = [];
						currentDatasetModel.data.x.push(CSVfields[3].replace('\r', '').trim());
						currentDatasetModel.data.y.push(CSVfields[4].replace('\r', '').trim());
						if (!datasetManager2.getDatasetByID(id,type)) //significa che è dataset nuovo che non era ancora stato incontrato nel CSV
							datasetManager2.addDataset(id,type,currentDatasetModel);
					}
					else {
						bootbox.alert("You did not provide a numeric dataset, it will be ignored");
					}
				}else {
						bootbox.alert("<strong>" + CSVrow + "</strong>" + " Invalid row");
					}
			}
		}
	}
	
	var readFileGenericFunc = function(event){//parser generale, poi verranno usati quelli specifici
		var text = event.target.result;
		lines = text.split('\n');
		
		linesNum = lines.length;
		currentLine = 0;
		var line;
		for (var c = 0; c < lines.length; c++) {
			line = lines[c] ? lines[c].trim() : "";
			if (line && line.substr(0, CSV_COMMENT.length) !== CSV_COMMENT){
				datasetType = (line.split(',')[2]).trim().toLowerCase();
				if(datasetType === 'text' || datasetType === 'text2')
					readFileTextDatasetFunc(line,c,datasetManager2);
				else if (datasetType === 'numeric')
					readFileNumericDatasetFunc(line,c,datasetManager2);
				else {
					bootbox.alert('<strong>' + line + '</strong> seems to be an invalid row');
					break;
				}
			}
			currentLine++;
		}//dopo aver letto ogni riga di ogni file aggiorniamo i dati
		if (l == files.length && (currentLine === linesNum)) {
			updateavailableDatasetFromJSON(datasetManager2);
			var numeric=false;
			for(key in NUMERIC_ALG_NAME){
				if(NUMERIC_ALG_NAME[key] === currentAlgName)
				numeric=true;
			}
			if(numeric)initPage('numeric');
			else initPage('text');
		}
	}

	
	for (l = 0; l < files.length; l++) {
		var reader = new FileReader();//per ogni file in input istanziamo un reader
		reader.onload = (readFileGenericFunc);
		reader.readAsText(files[l]);
	}
	return datasetManager2;
}

//fonte W3School
function setCookie(cname, cvalue, exdays) {
	var d = new Date();
	d.setTime(d.getTime() + (exdays*24*60*60*1000));
	var expires = "expires="+ d.toUTCString();
	document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
}

//fonte W3School
function getCookie(cname) {
	var name = cname + "=";
	var decodedCookie = decodeURIComponent(document.cookie);
	var ca = decodedCookie.split(';');
	for(var i = 0; i <ca.length; i++) {
		var c = ca[i];
		while (c.charAt(0) == ' ') {
			c = c.substring(1);
		}
		if (c.indexOf(name) == 0) {
			return c.substring(name.length, c.length);
		}
	}
	return "";
}
